/*
 * Copyright (C) 2013, The Android Open Source Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#include "dictionary/structure/v4/ver4_patricia_trie_reading_utils.h"

#include "dictionary/utils/byte_array_utils.h"

namespace latinime {

/* static */ int Ver4PatriciaTrieReadingUtils::getTerminalIdAndAdvancePosition(
        const uint8_t *const buffer, int *pos) {
    return ByteArrayUtils::readUint32AndAdvancePosition(buffer, pos);
}

} // namespace latinime
